System.ServiceModel 4.0.0.0 System.Enum

When applying the to a method, this mode specifies which set of roles to use when authorizing access. By default, the attribute uses Windows groups (such as Administrator or Users) to specify the role to which the user must belong.

To set the mode programmatically, create an instance of the ServiceHost class, then find the in its collection of behaviors, and set the to the appropriate enumeration. The following example sets the property to .

code reference: PrincipalPermissionMode#1

You can also set the behavior in configuration by adding a <serviceAuthorization> element to the serviceBehaviors section of a configuration file, as shown in the following code.

code reference: PrincipalPermissionMode#10

The enumeration affects how the attribute authorizes a user when it is applied to a method. The following example applies the attribute to a method and demands that the user belong to the Users group on the computer. This code works only when the is set to UseWindowsGroup (the default setting).

code reference: PrincipalPermissionMode#2

## UseAspNetRoles

The value is used for all credential types. This mode enables indigo1 to use the ASP.NET role provider to make authorization decisions.

When the credential for a service is an X.509 certificate, you can set the Name property of the to a string that consists of the concatenated values of the Subject field and the Thumbprint field, as shown in the following example.

code reference: PrincipalPermissionMode#3

The concatenated string consists of the subject and thumbprint values separated by a semicolon and a space.

It is also possible for a certificate to have a Subject field set to a null string. In that case, you can set the Name property to a semicolon followed by a space and then the thumbprint, as shown in the following example.

code reference: PrincipalPermissionMode#4

If an ASP.NET role provider is present, you can also set the property to a role in the database. By default, the database is represented by the . You can also set a custom role provider with the property of the class. The following code sets the role to Administrators. Note that the role provider must map the user account to that role.

code reference: PrincipalPermissionMode#13

crabout the ASP.NET Role provider, see How To: Use Role Manager in ASP.NET 2.0.

crabout using indigo2 and the role provider, see How To: Use the ASP.NET Role Provider.

## Custom

When the property is set to , you must also provide a custom class that implements the class. This class is responsible for providing the caller's IPrincipal representation inside the collection. It must store the IPrincipal instance to the properties collection using the "Principal" string key, as shown in the following example.

`evaluationContext.Properties["Principal"]=new CustomPrincipal(identity);`

## Background

The role-based security in dnprdnshort enables applications to specify authorizations through code. By specifying the demand, the must satisfy the PrincipalPermission requirement. For example, that the user must be in a specific role or group. Otherwise, the thread is not authorized to execute the code, which results in an exception. indigo2 provides a set of selections to specify the based on accordingly.

Sets the mode for authorization checks when using the to control access to a method.

- Field
  4.0.0.0
  System.ServiceModel.Description.PrincipalPermissionMode

  Enables the user to specify a custom class for .

- Field
  4.0.0.0
  System.ServiceModel.Description.PrincipalPermissionMode

  is not set.

- Field
  4.0.0.0
  System.ServiceModel.Description.PrincipalPermissionMode

  is set based on the vstecasp role provider ().

- Field
  4.0.0.0
  System.ServiceModel.Description.PrincipalPermissionMode

  is set based on Windows (). If the user identity is not associated with a Windows account, anonymous Windows is used.